Option Explicit

Public Sub MainVBA()
	On Error Resume Next
	
	Dim xlApp As Excel.Application
	Dim xlBook As Excel.Workbook
	Dim objSheetTarget As Excel.Worksheet

	Dim lngRowSourceBeg As Long           '    . 
	Dim lngColSourceBeg As Long           '    . 
	Dim lngRowSourceEnd As Long           '  .  . 
	Dim lngColSourceEnd As Long           '  .  . 
	Dim lngRowSourceCur As Long           '   . . 
	Dim lngColSourceCur As Long           '   . . 
	Dim lngRowName1     As Long
	Dim lngRowName2     As Long
	Dim lngSheetID      As Long
	Dim lngRowTargetCur As Long           '
	Dim lngColTargetCur As Long           '
	Dim objSheetSource  As Worksheet      '
	
	Dim fs As Variant
	Set fs = CreateObject("Scripting.FileSystemObject")
	
	Dim varValue As Variant
	Dim varNewFileName As Variant
	Dim lngIndex As Long
		
    Set xlApp = CreateObject("Excel.Application")
    Set xlBook = xlApp.Workbooks.Add
	
   	lngRowTargetCur = 1: lngColTargetCur = 1
	
	For lngSheetID=2 TO WorkSheets.Count
		'       
		Set objSheetSource = Worksheets(lngSheetID)  '  
		'Set objSheetTarget = Worksheets(2)  '   ( )
		Set objSheetTarget = xlBook.Worksheets(1) '   ( )
		
		objSheetSource.Activate

        Columns("B:B").NumberFormat = "mm/dd/yyyy"

		With objSheetSource.UsedRange
			lngRowSourceBeg = .Row
			lngColSourceBeg = .Column
			lngRowSourceEnd = lngRowSourceBeg + .Rows.Count - 1
			lngColSourceEnd = lngColSourceBeg + .Columns.Count - 1
		End With
		'  
		For lngRowSourceCur = lngRowSourceBeg To lngRowSourceEnd
			varValue = objSheetSource.Cells(lngRowSourceCur, 1)
			If Not IsEmpty(varValue) <> 0 Then
				If objSheetSource.Cells(lngRowSourceCur, 1).Font.Bold = True And _
					(IsEmpty(objSheetSource.Cells(IIf(lngRowSourceCur > 1, lngRowSourceCur - 1, 1), 1)) Or _
					objSheetSource.Cells(IIf(lngRowSourceCur > 1, lngRowSourceCur - 1, 1), 1).Font.Underline > 0) Then
					
					 lngRowName1 = lngRowSourceCur + 1
					 lngRowName2 = lngRowSourceCur + 2
					 lngRowSourceCur = lngRowSourceCur + 3
					 
					 Do
						For lngColSourceCur = 3 To lngColSourceEnd
						   If Not IsEmpty(objSheetSource.Cells(lngRowSourceCur, lngColSourceCur)) Then
							   With objSheetTarget
								   .Cells(lngRowTargetCur, 1) = varValue
								   objSheetSource.Cells(lngRowSourceCur, 1).Select
								   '.Cells(lngRowTargetCur, 2) = CDate(ActiveCell.Value)
								   .Cells(lngRowTargetCur, 2) = ActiveCell.Value
								   .Cells(lngRowTargetCur, 3) = objSheetSource.Cells(lngRowSourceCur, 2)
								   objSheetSource.Cells(lngRowName1, lngColSourceCur).Select
								   .Cells(lngRowTargetCur, 4) = ActiveCell.Value
								   .Cells(lngRowTargetCur, 5) = objSheetSource.Cells(lngRowName2, lngColSourceCur)
								   .Cells(lngRowTargetCur, 6) = objSheetSource.Cells(lngRowSourceCur, lngColSourceCur)
								   .Columns("A:F").Columns.AutoFit
								   lngRowTargetCur = lngRowTargetCur + 1
							   End With
						   End If
						Next lngColSourceCur
						lngRowSourceCur = lngRowSourceCur + 1
					Loop Until IsEmpty(objSheetSource.Cells(lngRowSourceCur, 2))
				End If
			End If
		Next lngRowSourceCur
    Next lngSheetID
	
	varNewFileName = Replace(ActiveWorkbook.FullName, ActiveWorkbook.Name, "")&"_"&ActiveWorkbook.Name
	if fs.FileExists(varNewFileName) = True Then
		Kill varNewFileName '  
	End If
	
	xlApp.ActiveWorkbook.SaveAs varNewFileName, xlApp.ActiveWorkbook.FileFormat, , , false, false, 1, 2
    
    ' Excel,   Quit  Application
    xlApp.ActiveWorkbook.Close
    xlApp.Application.Quit
	
    '  
    Set objSheetTarget = Nothing
End Sub


